/*
 *  /MathJax/extensions/a11y/semantic-enrich.js
 *
 *  Copyright (c) 2009-2018 The MathJax Consortium
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

MathJax.Extension["semantic-enrich"]={version:"1.4.0",config:MathJax.Hub.CombineConfig("semantic-enrich",{disabled:false}),dependents:[],running:false,mstyleLookup:{mi:["mathvariant"],mo:["mathvariant","accent","largeop","form","fence","separator","movablelimits"],mn:["mathvariant"],mtext:["mathvariant"],ms:["mathvariant"],mfrac:["linethickness"],mfenced:["open","close","separators"],menclose:["notation"],munder:["accentunder"],mover:["accent"],munderover:["accent","accentunder"]},Filter:function(a,e,b){delete a.enriched;if(this.config.disabled){return}try{this.running=true;var c=sre.Enrich.semanticMathmlSync(a.root.toMathML());a.root=MathJax.InputJax.MathML.Parse.prototype.MakeMML(c);a.root.inputID=b.id;a.enriched=true;this.running=false}catch(d){this.running=false;throw d}},Enable:function(b,a){this.config.disabled=false;if(b){MathJax.Hub.Queue(["Reprocess",MathJax.Hub])}},Disable:function(d,c){this.config.disabled=true;for(var a=this.dependents.length-1;a>=0;a--){var b=this.dependents[a];if(b.Disable){b.Disable(false,c)}}if(d){MathJax.Hub.Queue(["Reprocess",MathJax.Hub])}},Dependent:function(a){this.dependents.push(a)}};(function(){var a=MathJax.Ajax.config.path;if(!a.a11y){a.a11y=HUB.config.root+"/extensions/a11y"}if(!a.SRE){a.SRE=MathJax.Ajax.fileURL(a.a11y)}MathJax.Ajax.Load("[SRE]/mathjax-sre.js");MathJax.Hub.Register.StartupHook("Sre Ready",["loadComplete",MathJax.Ajax,"[SRE]/mathjax-sre.js"])})();MathJax.Callback.Queue(["Require",MathJax.Ajax,"[MathJax]/jax/element/mml/jax.js"],["Require",MathJax.Ajax,"[MathJax]/jax/input/MathML/config.js"],["Require",MathJax.Ajax,"[MathJax]/jax/input/MathML/jax.js"],["Require",MathJax.Ajax,"[MathJax]/extensions/toMathML.js"],MathJax.Hub.Register.StartupHook("Sre Ready",function(){var a=MathJax.ElementJax.mml,c=MathJax.Extension["semantic-enrich"];a.mbase.Augment({toMathMLattributes:function(){var h=(this.type==="mstyle"?a.math.prototype.defaults:this.defaults);var n=(this.attrNames||a.copyAttributeNames),o=a.skipAttributes,d=a.copyAttributes,f=(c.running?c.mstyleLookup[this.type]||[]:[]);var l=[],k=(this.attr||{});if(this.type==="math"&&(!this.attr||!("xmlns" in this.attr))){l.push('xmlns="http://www.w3.org/1998/Math/MathML"')}if(!this.attrNames){for(var e in h){if(!o[e]&&!d[e]&&h.hasOwnProperty(e)){if(this[e]!=null&&this[e]!==h[e]){if(this.Get(e,null,1)!==this[e]){this.toMathMLaddAttr(l,e,this[e])}}}}}for(var j=0,g=n.length;j<g;j++){if(d[n[j]]===1&&!h.hasOwnProperty(n[j])){continue}value=k[n[j]];if(value==null){value=this[n[j]]}if(value!=null){this.toMathMLaddAttr(l,n[j],value)}}for(j=0,g=f.length;j<g;j++){e=f[j];if(h.hasOwnProperty(e)&&!l["_"+e]){value=this.Get(e,1);if(value!=null){this.toMathMLaddAttr(l,e,value)}}}this.toMathMLclass(l);if(l.length){return" "+l.join(" ")}else{return""}},toMathMLaddAttr:function(d,f,e){d.push(f+'="'+this.toMathMLquote(e)+'"');d["_"+f]=1}});var b=a.mo.prototype.setTeXclass;a.mo.Augment({setTeXclass:function(e){var d=this.getValues("form","lspace","rspace");if(this.useMMLspacing){this.texClass=a.TEXCLASS.NONE;return this}if(this.attr&&this.attr["data-semantic-added"]){this.texClass=this.prevClass=a.TEXCLASS.NONE;return e}return b.apply(this,arguments)}})}),function(){MathJax.Hub.postInputHooks.Add(["Filter",MathJax.Extension["semantic-enrich"]],50);MathJax.Hub.Startup.signal.Post("Semantic Enrich Ready");MathJax.Ajax.loadComplete("[a11y]/semantic-enrich.js")});
