/*
 *  /MathJax/extensions/TeX/mhchem3/mhchem.js
 *
 *  Copyright (c) 2009-2018 The MathJax Consortium
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

MathJax.Extension["TeX/mhchem"]={version:"3.2.0"};MathJax.Hub.Register.StartupHook("TeX Jax Ready",function(){var d=MathJax.InputJax.TeX;var c=MathJax.Object.Subclass({string:"",Init:function(e){this.string=e},Parse:function(e){try{return a.go(b.go(this.string,e))}catch(f){d.Error(f)}}});var b={};b.go=function(n,g){if(!n){return n}if(g===undefined){g="ce"}var i="0";var u={};u.parenthesisLevel=0;n=n.replace(/[\u2212\u2013\u2014\u2010]/g,"-");n=n.replace(/[\u2026]/g,"...");var y,v;var l=[];while(true){if(y!==n){v=10;y=n}else{v--}var j=b.stateMachines[g];var e=j.transitions.length;iterateTransitions:for(var x=0;x<e;x++){var q=j.transitions[x];var r=q.actions[i]||q.actions["*"]||null;if(r){var f=b.matchh(q.matchh,n);if(f){var m=b.concatNotUndefined([],r.action);var h=m.length;for(var k=0;k<h;k++){var w=m[k];var s;var p=undefined;if(w.type){p=w.option;w=w.type}if(typeof w==="string"){if(j.actions[w]){s=j.actions[w](u,f.matchh,p)}else{if(b.actions[w]){s=b.actions[w](u,f.matchh,p)}else{throw ["MhchemBugA","mhchem bug A. Please report. ("+w+")"]}}}else{if(typeof w==="function"){s=w(u,f.matchh)}}l=b.concatNotUndefined(l,s)}i=r.nextState||i;if(n.length>0){if(!r.revisit){n=f.remainder}if(!r.toContinue){break iterateTransitions}}else{return l}}}}if(v<=0){throw ["MhchemBugU","mhchem bug U. Please report."]}}};b.concatNotUndefined=function(f,e){if(!e){return f}if(!f){return[].concat(e)}return f.concat(e)};b.patterns={empty:/^$/,"else":/^./,else2:/^./,space:/^\s/,"space A":/^\s(?=[A-Z\\$])/,"a-z":/^[a-z]/,x:/^x/,"x$":/^x$/,"i$":/^i$/,letters:/^(?:[a-zA-Z\u03B1-\u03C9\u0391-\u03A9?@]|(?:\\(?:alpha|beta|gamma|delta|epsilon|zeta|eta|theta|iota|kappa|lambda|mu|nu|xi|omicron|pi|rho|sigma|tau|upsilon|phi|chi|psi|omega|Gamma|Delta|Theta|Lambda|Xi|Pi|Sigma|Upsilon|Phi|Psi|Omega)(?:\s+|\{\}|(?![a-zA-Z]))))+/,"\\greek":/^\\(?:alpha|beta|gamma|delta|epsilon|zeta|eta|theta|iota|kappa|lambda|mu|nu|xi|omicron|pi|rho|sigma|tau|upsilon|phi|chi|psi|omega|Gamma|Delta|Theta|Lambda|Xi|Pi|Sigma|Upsilon|Phi|Psi|Omega)(?:\s+|\{\}|(?![a-zA-Z]))/,"one lowercase latin letter $":/^(?:([a-z])(?:$|[^a-zA-Z]))$/,"$one lowercase latin letter$ $":/^\$(?:([a-z])(?:$|[^a-zA-Z]))\$$/,"one lowercase greek letter $":/^(?:\$?[\u03B1-\u03C9]\$?|\$?\\(?:alpha|beta|gamma|delta|epsilon|zeta|eta|theta|iota|kappa|lambda|mu|nu|xi|omicron|pi|rho|sigma|tau|upsilon|phi|chi|psi|omega)\s*\$?)(?:\s+|\{\}|(?![a-zA-Z]))$/,digits:/^[0-9]+/,"-9.,9":/^[+\-]?(?:[0-9]+(?:[,.][0-9]+)?|[0-9]*(?:\.[0-9]+))/,"-9.,9 no missing 0":/^[+\-]?[0-9]+(?:[.,][0-9]+)?/,"(-)(9.,9)(e)(99)":function(f){var e=f.match(/^(\+\-|\+\/\-|\+|\-|\\pm\s?)?([0-9]+(?:[,.][0-9]+)?|[0-9]*(?:\.[0-9]+)?)(\((?:[0-9]+(?:[,.][0-9]+)?|[0-9]*(?:\.[0-9]+)?)\))?(?:([eE]|\s*(\*|x|\\times|\u00D7)\s*10\^)([+\-]?[0-9]+|\{[+\-]?[0-9]+\}))?/);if(e&&e[0]){return{matchh:e.splice(1),remainder:f.substr(e[0].length)}}return null},"(-)(9)^(-9)":function(f){var e=f.match(/^(\+\-|\+\/\-|\+|\-|\\pm\s?)?([0-9]+(?:[,.][0-9]+)?|[0-9]*(?:\.[0-9]+)?)\^([+\-]?[0-9]+|\{[+\-]?[0-9]+\})/);if(e&&e[0]){return{matchh:e.splice(1),remainder:f.substr(e[0].length)}}return null},"state of aggregation $":function(g){var f=this["_findObserveGroups"](g,"",/^\([a-z]{1,3}(?=[\),])/,")","");if(f&&f.remainder.match(/^($|[\s,;\)\]\}])/)){return f}var e=g.match(/^(?:\((?:\\ca\s?)?\$[amothc]\$\))/);if(e){return{matchh:e[0],remainder:g.substr(e[0].length)}}return null},"_{(state of aggregation)}$":/^_\{(\([a-z]{1,3}\))\}/,"{[(":/^(?:\\\{|\[|\()/,")]}":/^(?:\)|\]|\\\})/,", ":/^[,;]\s*/,",":/^[,;]/,".":/^[.]/,". ":/^([.\u22C5\u00B7\u2022])\s*/,"...":/^\.\.\.(?=$|[^.])/,"* ":/^([*])\s*/,"^{(...)}":function(e){return this["_findObserveGroups"](e,"^{","","","}")},"^($...$)":function(e){return this["_findObserveGroups"](e,"^","$","$","")},"^a":/^\^([0-9]+|[^\\_])/,"^\\x{}{}":function(e){return this["_findObserveGroups"](e,"^",/^\\[a-zA-Z]+\{/,"}","","","{","}","",true)},"^\\x{}":function(e){return this["_findObserveGroups"](e,"^",/^\\[a-zA-Z]+\{/,"}","")},"^\\x":/^\^(\\[a-zA-Z]+)\s*/,"^(-1)":/^\^(-?\d+)/,"'":/^'/,"_{(...)}":function(e){return this["_findObserveGroups"](e,"_{","","","}")},"_($...$)":function(e){return this["_findObserveGroups"](e,"_","$","$","")},_9:/^_([+\-]?[0-9]+|[^\\])/,"_\\x{}{}":function(e){return this["_findObserveGroups"](e,"_",/^\\[a-zA-Z]+\{/,"}","","","{","}","",true)},"_\\x{}":function(e){return this["_findObserveGroups"](e,"_",/^\\[a-zA-Z]+\{/,"}","")},"_\\x":/^_(\\[a-zA-Z]+)\s*/,"^_":/^(?:\^(?=_)|\_(?=\^)|[\^_]$)/,"{}":/^\{\}/,"{...}":function(e){return this["_findObserveGroups"](e,"","{","}","")},"{(...)}":function(e){return this["_findObserveGroups"](e,"{","","","}")},"$...$":function(e){return this["_findObserveGroups"](e,"","$","$","")},"${(...)}$":function(e){return this["_findObserveGroups"](e,"${","","","}$")},"$(...)$":function(e){return this["_findObserveGroups"](e,"$","","","$")},"=<>":/^[=<>]/,"#":/^[#\u2261]/,"+":/^\+/,"-$":/^-(?=[\s_},;\]/]|$|\([a-z]+\))/,"-9":/^-(?=[0-9])/,"- orbital overlap":/^-(?=(?:[spd]|sp)(?:$|[\s,;\)\]\}]))/,"-":/^-/,"pm-operator":/^(?:\\pm|\$\\pm\$|\+-|\+\/-)/,operator:/^(?:\+|(?:[\-=<>]|<<|>>|\\approx|\$\\approx\$)(?=\s|$|-?[0-9]))/,arrowUpDown:/^(?:v|\(v\)|\^|\(\^\))(?=$|[\s,;\)\]\}])/,"\\bond{(...)}":function(e){return this["_findObserveGroups"](e,"\\bond{","","","}")},"->":/^(?:<->|<-->|->|<-|<=>>|<<=>|<=>|[\u2192\u27F6\u21CC])/,CMT:/^[CMT](?=\[)/,"[(...)]":function(e){return this["_findObserveGroups"](e,"[","","","]")},"1st-level escape":/^(&|\\\\|\\hline)\s*/,"\\,":/^(?:\\[,\ ;:])/,"\\x{}{}":function(e){return this["_findObserveGroups"](e,"",/^\\[a-zA-Z]+\{/,"}","","","{","}","",true)},"\\x{}":function(e){return this["_findObserveGroups"](e,"",/^\\[a-zA-Z]+\{/,"}","")},"\\ca":/^\\ca(?:\s+|(?![a-zA-Z]))/,"\\x":/^(?:\\[a-zA-Z]+\s*|\\[_&{}%])/,orbital:/^(?:[0-9]{1,2}[spdfgh]|[0-9]{0,2}sp)(?=$|[^a-zA-Z])/,others:/^[\/~|]/,"\\frac{(...)}":function(e){return this["_findObserveGroups"](e,"\\frac{","","","}","{","","","}")},"\\overset{(...)}":function(e){return this["_findObserveGroups"](e,"\\overset{","","","}","{","","","}")},"\\underset{(...)}":function(e){return this["_findObserveGroups"](e,"\\underset{","","","}","{","","","}")},"\\underbrace{(...)}":function(e){return this["_findObserveGroups"](e,"\\underbrace{","","","}_","{","","","}")},"\\color{(...)}0":function(e){return this["_findObserveGroups"](e,"\\color{","","","}")},"\\color{(...)}{(...)}1":function(e){return this["_findObserveGroups"](e,"\\color{","","","}","{","","","}")},"\\color(...){(...)}2":function(e){return this["_findObserveGroups"](e,"\\color","\\","",/^(?=\{)/,"{","","","}")},"\\ce{(...)}":function(e){return this["_findObserveGroups"](e,"\\ce{","","","}")},"oxidation$":/^(?:[+-][IVX]+|\\pm\s*0|\$\\pm\$\s*0)$/,"d-oxidation$":/^(?:[+-]?\s?[IVX]+|\\pm\s*0|\$\\pm\$\s*0)$/,"roman numeral":/^[IVX]+/,"1/2$":/^[+\-]?(?:[0-9]+|\$[a-z]\$|[a-z])\/[0-9]+(?:\$[a-z]\$|[a-z])?$/,amount:function(f){var g;g=f.match(/^(?:(?:(?:\([+\-]?[0-9]+\/[0-9]+\)|[+\-]?(?:[0-9]+|\$[a-z]\$|[a-z])\/[0-9]+|[+\-]?[0-9]+[.,][0-9]+|[+\-]?\.[0-9]+|[+\-]?[0-9]+)(?:[a-z](?=\s*[A-Z]))?)|[+\-]?[a-z](?=\s*[A-Z])|\+(?!\s))/);if(g){return{matchh:g[0],remainder:f.substr(g[0].length)}}var e=this["_findObserveGroups"](f,"","$","$","");if(e){g=e.matchh.match(/^\$(?:\(?[+\-]?(?:[0-9]*[a-z]?[+\-])?[0-9]*[a-z](?:[+\-][0-9]*[a-z]?)?\)?|\+|-)\$$/);if(g){return{matchh:g[0],remainder:f.substr(g[0].length)}}}return null},amount2:function(e){return this["amount"](e)},"(KV letters),":/^(?:[A-Z][a-z]{0,2}|i)(?=,)/,"formula$":function(e){if(e.match(/^\([a-z]+\)$/)){return null}var f=e.match(/^(?:[a-z]|(?:[0-9\ \+\-\,\.\(\)]+[a-z])+[0-9\ \+\-\,\.\(\)]*|(?:[a-z][0-9\ \+\-\,\.\(\)]+)+[a-z]?)$/);if(f){return{matchh:f[0],remainder:e.substr(f[0].length)}}return null},uprightEntities:/^(?:pH|pOH|pC|pK|iPr|iBu)(?=$|[^a-zA-Z])/,"/":/^\s*(\/)\s*/,"//":/^\s*(\/\/)\s*/,"*":/^\s*\*\s*/,_findObserveGroups:function(p,g,q,n,r,i,h,j,o,s){var k=this["__match"](p,g);if(k===null){return null}p=p.substr(k.length);k=this["__match"](p,q);if(k===null){return null}var l=this["__findObserveGroups"](p,k.length,n||r);if(l===null){return null}var t=p.substring(0,(n?l.endMatchEnd:l.endMatchBegin));if(!(i||h)){return{matchh:t,remainder:p.substr(l.endMatchEnd)}}else{var f=this["_findObserveGroups"](p.substr(l.endMatchEnd),i,h,j,o);if(f===null){return null}var m=[t,f.matchh];if(s){m=m.join("")}return{matchh:m,remainder:f.remainder}}},__match:function(e,f){if(typeof f==="string"){if(e.indexOf(f)!==0){return null}return f}else{var g=e.match(f);if(!g){return null}return g[0]}},__findObserveGroups:function(f,g,k){var h=0;while(g<f.length){var e=f.charAt(g);var j=this["__match"](f.substr(g),k);if(j!==null&&h===0){return{endMatchBegin:g,endMatchEnd:g+j.length}}else{if(e==="{"){h++}else{if(e==="}"){if(h===0){throw ["ExtraCloseMissingOpen","Extra close brace or missing open brace"]}else{h--}}}}g++}if(h>0){return null}return null}};b.matchh=function(e,f){var g=b.patterns[e];if(g===undefined){throw ["MhchemBugP","mhchem bug P. Please report. ("+e+")"]}else{if(typeof g==="function"){return b.patterns[e](f)}else{var i=f.match(g);if(i){var h;if(i[2]){h=[i[1],i[2]]}else{if(i[1]){h=i[1]}else{h=i[0]}}return{matchh:h,remainder:f.substr(i[0].length)}}return null}}};b.actions={"a=":function(f,e){f.a=(f.a||"")+e},"b=":function(f,e){f.b=(f.b||"")+e},"p=":function(f,e){f.p=(f.p||"")+e},"o=":function(f,e){f.o=(f.o||"")+e},"q=":function(f,e){f.q=(f.q||"")+e},"d=":function(f,e){f.d=(f.d||"")+e},"rm=":function(f,e){f.rm=(f.rm||"")+e},"text=":function(f,e){f.text=(f.text||"")+e},insert:function(g,e,f){return{type:f}},"insert+p1":function(g,e,f){return{type:f,p1:e}},"insert+p1+p2":function(g,e,f){return{type:f,p1:e[0],p2:e[1]}},copy:function(f,e){return e},rm:function(f,e){return{type:"rm",p1:e}},text:function(f,e){return b.go(e,"text")},"{text}":function(f,e){var g=["{"];g=b.concatNotUndefined(g,b.go(e,"text"));g=b.concatNotUndefined(g,"}");return g},"tex-math":function(f,e){return b.go(e,"tex-math")},"tex-math tight":function(f,e){return b.go(e,"tex-math tight")},bond:function(f,e,g){return{type:"bond",kind:g||e}},"color0-output":function(f,e){return{type:"color0",color:e[0]}},ce:function(f,e){return b.go(e)},"1/2":function(f,e){var g;if(e.match(/^[+\-]/)){g=[e.substr(0,1)];e=e.substr(1)}var h=e.match(/^([0-9]+|\$[a-z]\$|[a-z])\/([0-9]+)(\$[a-z]\$|[a-z])?$/);h[1]=h[1].replace(/\$/g,"");g=b.concatNotUndefined(g,{type:"frac",p1:h[1],p2:h[2]});if(h[3]){h[3]=h[3].replace(/\$/g,"");g=b.concatNotUndefined(g,{type:"tex-math",p1:h[3]})}return g},"9,9":function(f,e){return b.go(e,"9,9")}};b.stateMachines={};b.createTransitions=function(e){var m,k,n,h;var j={};for(m in e){if(m.indexOf("|")!==-1){n=m.split("|");for(h=0;h<n.length;h++){j[n[h]]=e[m]}}else{j[m]=e[m]}}var l=[];for(m in j){var g={};var f=j[m];for(k in f){if(k.indexOf("|")!==-1){n=k.split("|");for(h=0;h<n.length;h++){g[n[h]]=f[k]}}else{g[k]=f[k]}}l.push({matchh:m,actions:g})}return l};b.stateMachines.ce={transitions:b.createTransitions({empty:{"*":{action:"output"}},"else":{"0|1|2":{action:"beginsWithBond=false",revisit:true,toContinue:true}},"oxidation$":{"0":{action:"oxidation-output"}},CMT:{r:{action:"rdt=",nextState:"rt"},rd:{action:"rqt=",nextState:"rdt"}},arrowUpDown:{"0|1|2|as":{action:["sb=false","output","operator"],nextState:"1"}},uprightEntities:{"0|1|2":{action:["o=","output"],nextState:"1"}},orbital:{"0|1|2|3":{action:"o=",nextState:"o"}},"->":{"0|1|2|3":{action:"r=",nextState:"r"},"a|as":{action:["output","r="],nextState:"r"},"*":{action:["output","r="],nextState:"r"}},"+":{o:{action:"d= kv",nextState:"d"},"d|D":{action:"d=",nextState:"d"},q:{action:"d=",nextState:"qd"},"qd|qD":{action:"d=",nextState:"qd"},dq:{action:["output","d="],nextState:"d"},"3":{action:["sb=false","output","operator"],nextState:"0"}},amount:{"0|2":{action:"a=",nextState:"a"}},"pm-operator":{"0|1|2|a|as":{action:["sb=false","output",{type:"operator",option:"\\pm"}],nextState:"0"}},operator:{"0|1|2|a|as":{action:["sb=false","output","operator"],nextState:"0"}},"-$":{"o|q":{action:["charge or bond","output"],nextState:"qd"},d:{action:"d=",nextState:"d"},D:{action:["output",{type:"bond",option:"-"}],nextState:"3"},q:{action:"d=",nextState:"qd"},qd:{action:"d=",nextState:"qd"},"qD|dq":{action:["output",{type:"bond",option:"-"}],nextState:"3"}},"-9":{"3|o":{action:["output",{type:"insert",option:"hyphen"}],nextState:"3"}},"- orbital overlap":{o:{action:{type:"- after o",option:true},nextState:"2"},d:{action:{type:"- after d",option:true},nextState:"2"}},"-":{"0|1|2":{action:[{type:"output",option:1},"beginsWithBond=true",{type:"bond",option:"-"}],nextState:"3"},"3":{action:{type:"bond",option:"-"}},a:{action:["output",{type:"insert",option:"hyphen"}],nextState:"2"},as:{action:[{type:"output",option:2},{type:"bond",option:"-"}],nextState:"3"},b:{action:"b="},o:{action:"- after o",nextState:"2"},q:{action:"- after o",nextState:"2"},"d|qd|dq":{action:"- after d",nextState:"2"},"D|qD|p":{action:["output",{type:"bond",option:"-"}],nextState:"3"}},amount2:{"1|3":{action:"a=",nextState:"a"}},letters:{"0|1|2|3|a|as|b|p|bp|o":{action:"o=",nextState:"o"},"q|dq":{action:["output","o="],nextState:"o"},"d|D|qd|qD":{action:"o after d",nextState:"o"}},digits:{o:{action:"q=",nextState:"q"},"d|D":{action:"q=",nextState:"dq"},q:{action:["output","o="],nextState:"o"},a:{action:"o=",nextState:"o"}},"space A":{"b|p|bp":{}},space:{a:{nextState:"as"},"0":{action:"sb=false"},"1|2":{action:"sb=true"},"r|rt|rd|rdt|rdq":{action:"output",nextState:"0"},"*":{action:["output","sb=true"],nextState:"1"}},"1st-level escape":{"1|2":{action:["output",{type:"insert+p1",option:"1st-level escape"}]},"*":{action:["output",{type:"insert+p1",option:"1st-level escape"}],nextState:"0"}},"[(...)]":{"r|rt":{action:"rd=",nextState:"rd"},"rd|rdt":{action:"rq=",nextState:"rdq"}},"...":{"o|d|D|dq|qd|qD":{action:["output",{type:"bond",option:"..."}],nextState:"3"},"*":{action:[{type:"output",option:1},{type:"insert",option:"ellipsis"}],nextState:"1"}},". |* ":{"*":{action:["output",{type:"insert",option:"addition compound"}],nextState:"1"}},"state of aggregation $":{"*":{action:["output","state of aggregation"],nextState:"1"}},"{[(":{"a|as|o":{action:["o=","output","parenthesisLevel++"],nextState:"2"},"0|1|2|3":{action:["o=","output","parenthesisLevel++"],nextState:"2"},"*":{action:["output","o=","output","parenthesisLevel++"],nextState:"2"}},")]}":{"0|1|2|3|b|p|bp|o":{action:["o=","parenthesisLevel--"],nextState:"o"},"a|as|d|D|q|qd|qD|dq":{action:["output","o=","parenthesisLevel--"],nextState:"o"}},", ":{"*":{action:["output","comma"],nextState:"0"}},"^_":{"*":{}},"^{(...)}|^($...$)":{"0|1|2|as":{action:"b=",nextState:"b"},p:{action:"b=",nextState:"bp"},"3|o":{action:"d= kv",nextState:"D"},q:{action:"d=",nextState:"qD"},"d|D|qd|qD|dq":{action:["output","d="],nextState:"D"}},"^a|^\\x{}{}|^\\x{}|^\\x|'":{"0|1|2|as":{action:"b=",nextState:"b"},p:{action:"b=",nextState:"bp"},"3|o":{action:"d= kv",nextState:"d"},q:{action:"d=",nextState:"qd"},"d|qd|D|qD":{action:"d="},dq:{action:["output","d="],nextState:"d"}},"_{(state of aggregation)}$":{"d|D|q|qd|qD|dq":{action:["output","q="],nextState:"q"}},"_{(...)}|_($...$)|_9|_\\x{}{}|_\\x{}|_\\x":{"0|1|2|as":{action:"p=",nextState:"p"},b:{action:"p=",nextState:"bp"},"3|o":{action:"q=",nextState:"q"},"d|D":{action:"q=",nextState:"dq"},"q|qd|qD|dq":{action:["output","q="],nextState:"q"}},"=<>":{"0|1|2|3|a|as|o|q|d|D|qd|qD|dq":{action:[{type:"output",option:2},"bond"],nextState:"3"}},"#":{"0|1|2|3|a|as|o":{action:[{type:"output",option:2},{type:"bond",option:"#"}],nextState:"3"}},"{}":{"*":{action:{type:"output",option:1},nextState:"1"}},"{...}":{"0|1|2|3|a|as|b|p|bp":{action:"o=",nextState:"o"},"o|d|D|q|qd|qD|dq":{action:["output","o="],nextState:"o"}},"$...$":{a:{action:"a="},"0|1|2|3|as|b|p|bp|o":{action:"o=",nextState:"o"},"as|o":{action:"o="},"q|d|D|qd|qD|dq":{action:["output","o="],nextState:"o"}},"\\bond{(...)}":{"*":{action:[{type:"output",option:2},"bond"],nextState:"3"}},"\\frac{(...)}":{"*":{action:[{type:"output",option:1},"frac-output"],nextState:"3"}},"\\overset{(...)}":{"*":{action:[{type:"output",option:2},"overset-output"],nextState:"3"}},"\\underset{(...)}":{"*":{action:[{type:"output",option:2},"underset-output"],nextState:"3"}},"\\underbrace{(...)}":{"*":{action:[{type:"output",option:2},"underbrace-output"],nextState:"3"}},"\\color{(...)}{(...)}1|\\color(...){(...)}2":{"*":{action:[{type:"output",option:2},"color-output"],nextState:"3"}},"\\color{(...)}0":{"*":{action:[{type:"output",option:2},"color0-output"]}},"\\ce{(...)}":{"*":{action:[{type:"output",option:2},"ce"],nextState:"3"}},"\\,":{"*":{action:[{type:"output",option:1},"copy"],nextState:"1"}},"\\x{}{}|\\x{}|\\x":{"0|1|2|3|a|as|b|p|bp|o|c0":{action:["o=","output"],nextState:"3"},"*":{action:["output","o=","output"],nextState:"3"}},others:{"*":{action:[{type:"output",option:1},"copy"],nextState:"3"}},else2:{a:{action:"a to o",nextState:"o",revisit:true},as:{action:[{type:"output"},"sb=true"],nextState:"1",revisit:true},"r|rt|rd|rdt|rdq":{action:["output"],nextState:"0",revisit:true},"*":{action:["output","copy"],nextState:"3"}}}),actions:{"o after d":function(f,e){var g;if(f.d.match(/^[0-9]+$/)){var h=f.d;f.d=undefined;g=this["output"](f);f.b=h}else{g=this["output"](f)}b.actions["o="](f,e);return g},"d= kv":function(f,e){f.d=e;f["d-type"]="kv"},"charge or bond":function(f,e){if(f.beginsWithBond){var g=b.concatNotUndefined(g,this["output"](f));g=b.concatNotUndefined(g,b.actions.bond(f,e,"-"));return g}else{f.d=e}},"- after o":function(f,e,i){var h=i||this["_hyphenFollows"](f,e);var g=b.concatNotUndefined(null,this["output"](f,e));if(h){g=b.concatNotUndefined(g,{type:"hyphen"})}else{g=b.concatNotUndefined(g,b.actions.bond(f,e,"-"))}return g},"- after d":function(f,e,j){var i=j||this["_hyphenFollows"](f,e);var g;if(i){g=b.concatNotUndefined(g,this["output"](f,e));g=b.concatNotUndefined(g,{type:"hyphen"})}else{var h=b.matchh("digits",f.d||"");if(h&&h.remainder===""){g=b.concatNotUndefined(null,b.actions["d="](f,e));g=b.concatNotUndefined(g,this["output"](f))}else{g=b.concatNotUndefined(g,this["output"](f,e));g=b.concatNotUndefined(g,b.actions.bond(f,e,"-"))}}return g},_hyphenFollows:function(f,e){var j=b.matchh("orbital",f.o||"");var i=b.matchh("one lowercase greek letter $",f.o||"");var h=b.matchh("one lowercase latin letter $",f.o||"");var g=b.matchh("$one lowercase latin letter$ $",f.o||"");var k=e==="-"&&(j&&j.remainder===""||i||h||g);if(k&&!f.a&&!f.b&&!f.p&&!f.d&&!f.q&&!j&&h){f.o="$"+f.o+"$"}return k},"a to o":function(f,e){f.o=f.a;f.a=undefined},"sb=true":function(f,e){f.sb=true},"sb=false":function(f,e){f.sb=false},"beginsWithBond=true":function(f,e){f.beginsWithBond=true},"beginsWithBond=false":function(f,e){f.beginsWithBond=false},"parenthesisLevel++":function(f,e){f.parenthesisLevel++},"parenthesisLevel--":function(f,e){f.parenthesisLevel--},"state of aggregation":function(f,e){e=b.go(e,"o");return{type:"state of aggregation",p1:e}},comma:function(g,e){var f=e.replace(/\s*$/,"");var h=(f!==e);if(h&&g.parenthesisLevel===0){return{type:"comma enumeration L",p1:f}}else{return{type:"comma enumeration M",p1:f}}},output:function(f,e,i){var g;if(!f.r){g=[];if(!f.a&&!f.b&&!f.p&&!f.o&&!f.q&&!f.d&&!i){g=null}else{if(f.sb){g.push({type:"entitySkip"})}if(!f.o&&!f.q&&!f.d&&!f.b&&!f.p&&i!==2){f.o=f.a;f.a=undefined}else{if(!f.o&&!f.q&&!f.d&&(f.b||f.p)){f.o=f.a;f.d=f.b;f.q=f.p;f.a=f.b=f.p=undefined}else{if(f.o&&f["d-type"]==="kv"&&b.matchh("d-oxidation$",f.d||"")){f["d-type"]="oxidation"}else{if(f.o&&f["d-type"]==="kv"&&!f.q){f["d-type"]=undefined}}}}f.a=b.go(f.a,"a");f.b=b.go(f.b,"bd");f.p=b.go(f.p,"pq");f.o=b.go(f.o,"o");if(f["d-type"]==="oxidation"){f.d=b.go(f.d,"oxidation")}else{f.d=b.go(f.d,"bd")}f.q=b.go(f.q,"pq");g.push({type:"chemfive",a:f.a,b:f.b,p:f.p,o:f.o,q:f.q,d:f.d,"d-type":f["d-type"]})}}else{if(f.rdt==="M"){f.rd=b.go(f.rd,"tex-math")}else{if(f.rdt==="T"){f.rd=[{type:"text",p1:f.rd}]}else{f.rd=b.go(f.rd)}}if(f.rqt==="M"){f.rq=b.go(f.rq,"tex-math")}else{if(f.rqt==="T"){f.rq=[{type:"text",p1:f.rq}]}else{f.rq=b.go(f.rq)}}g={type:"arrow",r:f.r,rd:f.rd,rq:f.rq}}for(var h in f){if(h!=="parenthesisLevel"&&h!=="beginsWithBond"){delete f[h]}}return g},"oxidation-output":function(f,e){var g=["{"];g=b.concatNotUndefined(g,b.go(e,"oxidation"));g=g.concat(["}"]);return g},"frac-output":function(f,e){return{type:"frac-ce",p1:b.go(e[0]),p2:b.go(e[1])}},"overset-output":function(f,e){return{type:"overset",p1:b.go(e[0]),p2:b.go(e[1])}},"underset-output":function(f,e){return{type:"underset",p1:b.go(e[0]),p2:b.go(e[1])}},"underbrace-output":function(f,e){return{type:"underbrace",p1:b.go(e[0]),p2:b.go(e[1])}},"color-output":function(f,e){return{type:"color",color1:e[0],color2:b.go(e[1])}},"r=":function(f,e){f.r=(f.r||"")+e},"rdt=":function(f,e){f.rdt=(f.rdt||"")+e},"rd=":function(f,e){f.rd=(f.rd||"")+e},"rqt=":function(f,e){f.rqt=(f.rqt||"")+e},"rq=":function(f,e){f.rq=(f.rq||"")+e},operator:function(f,e,g){return{type:"operator",kind:(g||e)}}}};b.stateMachines.a={transitions:b.createTransitions({empty:{"*":{}},"1/2$":{"0":{action:"1/2"}},"else":{"0":{nextState:"1",revisit:true}},"$(...)$":{"*":{action:"tex-math tight",nextState:"1"}},",":{"*":{action:{type:"insert",option:"commaDecimal"}}},else2:{"*":{action:"copy"}}}),actions:{}};b.stateMachines.o={transitions:b.createTransitions({empty:{"*":{}},"1/2$":{"0":{action:"1/2"}},"else":{"0":{nextState:"1",revisit:true}},letters:{"*":{action:"rm"}},"\\ca":{"*":{action:{type:"insert",option:"circa"}}},"\\x{}{}|\\x{}|\\x":{"*":{action:"copy"}},"${(...)}$|$(...)$":{"*":{action:"tex-math"}},"{(...)}":{"*":{action:"{text}"}},else2:{"*":{action:"copy"}}}),actions:{}};b.stateMachines.text={transitions:b.createTransitions({empty:{"*":{action:"output"}},"{...}":{"*":{action:"text="}},"${(...)}$|$(...)$":{"*":{action:"tex-math"}},"\\greek":{"*":{action:["output","rm"]}},"\\,|\\x{}{}|\\x{}|\\x":{"*":{action:["output","copy"]}},"else":{"*":{action:"text="}}}),actions:{output:function(f,e){if(f.text){var g={type:"text",p1:f.text};for(var h in f){delete f[h]}return g}return null}}};b.stateMachines.pq={transitions:b.createTransitions({empty:{"*":{}},"state of aggregation $":{"*":{action:"state of aggregation"}},"i$":{"0":{nextState:"!f",revisit:true}},"(KV letters),":{"0":{action:"rm",nextState:"0"}},"formula$":{"0":{nextState:"f",revisit:true}},"1/2$":{"0":{action:"1/2"}},"else":{"0":{nextState:"!f",revisit:true}},"${(...)}$|$(...)$":{"*":{action:"tex-math"}},"{(...)}":{"*":{action:"text"}},"a-z":{f:{action:"tex-math"}},letters:{"*":{action:"rm"}},"-9.,9":{"*":{action:"9,9"}},",":{"*":{action:{type:"insert+p1",option:"comma enumeration S"}}},"\\color{(...)}{(...)}1|\\color(...){(...)}2":{"*":{action:"color-output"}},"\\color{(...)}0":{"*":{action:"color0-output"}},"\\ce{(...)}":{"*":{action:"ce"}},"\\,|\\x{}{}|\\x{}|\\x":{"*":{action:"copy"}},else2:{"*":{action:"copy"}}}),actions:{"state of aggregation":function(f,e){e=b.go(e,"o");return{type:"state of aggregation subscript",p1:e}},"color-output":function(f,e){return{type:"color",color1:e[0],color2:b.go(e[1],"pq")}}}};b.stateMachines.bd={transitions:b.createTransitions({empty:{"*":{}},"x$":{"0":{nextState:"!f",revisit:true}},"formula$":{"0":{nextState:"f",revisit:true}},"else":{"0":{nextState:"!f",revisit:true}},"-9.,9 no missing 0":{"*":{action:"9,9"}},".":{"*":{action:{type:"insert",option:"electron dot"}}},"a-z":{f:{action:"tex-math"}},x:{"*":{action:{type:"insert",option:"KV x"}}},letters:{"*":{action:"rm"}},"'":{"*":{action:{type:"insert",option:"prime"}}},"${(...)}$|$(...)$":{"*":{action:"tex-math"}},"{(...)}":{"*":{action:"text"}},"\\color{(...)}{(...)}1|\\color(...){(...)}2":{"*":{action:"color-output"}},"\\color{(...)}0":{"*":{action:"color0-output"}},"\\ce{(...)}":{"*":{action:"ce"}},"\\,|\\x{}{}|\\x{}|\\x":{"*":{action:"copy"}},else2:{"*":{action:"copy"}}}),actions:{"color-output":function(f,e){return{type:"color",color1:e[0],color2:b.go(e[1],"bd")}}}};b.stateMachines.oxidation={transitions:b.createTransitions({empty:{"*":{}},"roman numeral":{"*":{action:"roman-numeral"}},"${(...)}$|$(...)$":{"*":{action:"tex-math"}},"else":{"*":{action:"copy"}}}),actions:{"roman-numeral":function(f,e){return{type:"roman numeral",p1:e}}}};b.stateMachines["tex-math"]={transitions:b.createTransitions({empty:{"*":{action:"output"}},"\\ce{(...)}":{"*":{action:["output","ce"]}},"{...}|\\,|\\x{}{}|\\x{}|\\x":{"*":{action:"o="}},"else":{"*":{action:"o="}}}),actions:{output:function(f,e){if(f.o){var g={type:"tex-math",p1:f.o};for(var h in f){delete f[h]}return g}return null}}};b.stateMachines["tex-math tight"]={transitions:b.createTransitions({empty:{"*":{action:"output"}},"\\ce{(...)}":{"*":{action:["output","ce"]}},"{...}|\\,|\\x{}{}|\\x{}|\\x":{"*":{action:"o="}},"-|+":{"*":{action:"tight operator"}},"else":{"*":{action:"o="}}}),actions:{"tight operator":function(f,e){f.o=(f.o||"")+"{"+e+"}"},output:function(f,e){if(f.o){var g={type:"tex-math",p1:f.o};for(var h in f){delete f[h]}return g}return null}}};b.stateMachines["9,9"]={transitions:b.createTransitions({empty:{"*":{}},",":{"*":{action:"comma"}},"else":{"*":{action:"copy"}}}),actions:{comma:function(f,e){return{type:"commaDecimal"}}}};b.stateMachines.pu={transitions:b.createTransitions({empty:{"*":{action:"output"}},"{[(|)]}":{"0|a":{action:"copy"}},"(-)(9)^(-9)":{"0":{action:"number^",nextState:"a"}},"(-)(9.,9)(e)(99)":{"0":{action:"enumber",nextState:"a"}},space:{"0|a":{}},"pm-operator":{"0|a":{action:{type:"operator",option:"\\pm"},nextState:"0"}},operator:{"0|a":{action:"copy",nextState:"0"}},"//":{d:{action:"o=",nextState:"/"}},"/":{d:{action:"o=",nextState:"/"}},"{...}|else":{"0|d":{action:"d=",nextState:"d"},a:{action:["space","d="],nextState:"d"},"/|q":{action:"q=",nextState:"q"}}}),actions:{enumber:function(f,e){var g=[];if(e[0]==="+-"||e[0]==="+/-"){g.push("\\pm ")}else{if(e[0]){g.push(e[0])}}if(e[1]){g=b.concatNotUndefined(g,b.go(e[1],"pu-9,9"));if(e[2]){if(e[2].match(/[,.]/)){g=b.concatNotUndefined(g,b.go(e[2],"pu-9,9"))}else{g.push(e[2])}}e[3]=e[4]||e[3];if(e[3]){e[3]=e[3].trim();if(e[3]==="e"||e[3].substr(0,1)==="*"){g.push({type:"cdot"})}else{g.push({type:"times"})}}}if(e[3]){g.push("10^{"+e[5]+"}")}return g},"number^":function(f,e){var g=[];if(e[0]==="+-"||e[0]==="+/-"){g.push("\\pm ")}else{if(e[0]){g.push(e[0])}}g=b.concatNotUndefined(g,b.go(e[1],"pu-9,9"));g.push("^{"+e[2]+"}");return g},operator:function(f,e,g){return{type:"operator",kind:(g||e)}},space:function(f,e){return{type:"pu-space-1"}},output:function(f,e){var g;var i=b.matchh("{(...)}",f.d||"");if(i&&i.remainder===""){f.d=i.matchh}var h=b.matchh("{(...)}",f.q||"");if(h&&h.remainder===""){f.q=h.matchh}if(f.d){f.d=f.d.replace(/\u00B0C|\^oC|\^{o}C/g,"{}^{\\circ}C");f.d=f.d.replace(/\u00B0F|\^oF|\^{o}F/g,"{}^{\\circ}F")}if(f.q){f.d=b.go(f.d,"pu");f.q=f.q.replace(/\u00B0C|\^oC|\^{o}C/g,"{}^{\\circ}C");f.q=f.q.replace(/\u00B0F|\^oF|\^{o}F/g,"{}^{\\circ}F");f.q=b.go(f.q,"pu");if(f.o==="//"){g={type:"pu-frac",p1:f.d,p2:f.q}}else{g=f.d;if(f.d.length>1||f.q.length>1){g=b.concatNotUndefined(g,{type:" / "})}else{g=b.concatNotUndefined(g,{type:"/"})}g=b.concatNotUndefined(g,f.q)}}else{g=b.go(f.d,"pu-2")}for(var j in f){delete f[j]}return g}}};b.stateMachines["pu-2"]={transitions:b.createTransitions({empty:{"*":{action:"output"}},"*":{"*":{action:["output","cdot"],nextState:"0"}},"\\x":{"*":{action:"rm="},nextState:"1"},space:{"*":{action:["output","space"],nextState:"0"}},"^{(...)}|^(-1)":{"1":{action:"^(-1)"}},"-9.,9":{"0":{action:"rm=",nextState:"0"},"1":{action:"^(-1)",nextState:"0"}},"{...}|else":{"*":{action:"rm=",nextState:"1"}}}),actions:{cdot:function(f,e){return{type:"tight cdot"}},"^(-1)":function(f,e){f.rm+="^{"+e+"}"},space:function(f,e){return{type:"pu-space-2"}},output:function(g,e){var h;if(g.rm){var f=b.matchh("{(...)}",g.rm||"");if(f&&f.remainder===""){h=b.go(f.matchh,"pu")}else{h={type:"rm",p1:g.rm}}}for(var i in g){delete g[i]}return h}}};b.stateMachines["pu-9,9"]={transitions:b.createTransitions({empty:{"0":{action:"output-0"},o:{action:"output-o"}},",":{"0":{action:["output-0","comma"],nextState:"o"}},".":{"0":{action:["output-0","copy"],nextState:"o"}},"else":{"*":{action:"text="}}}),actions:{comma:function(f,e){return{type:"commaDecimal"}},"output-0":function(g,e){var h=[];if(g.text.length>4){var f=g.text.length%3;if(f===0){f=3}for(var j=g.text.length-3;j>0;j-=3){h.push(g.text.substr(j,3));h.push({type:"1000 separator"})}h.push(g.text.substr(0,f));h.reverse()}else{h.push(g.text)}for(var k in g){delete g[k]}return h},"output-o":function(g,e){var h=[];if(g.text.length>4){var f=g.text.length-3;for(var j=0;j<f;j+=3){h.push(g.text.substr(j,3));h.push({type:"1000 separator"})}h.push(g.text.substr(j))}else{h.push(g.text)}for(var k in g){delete g[k]}return h}}};var a={types:{chemfive:function(e){var f="";e.a=a.go2(e.a);e.b=a.go2(e.b);e.p=a.go2(e.p);e.o=a.go2(e.o);e.q=a.go2(e.q);e.d=a.go2(e.d);if(e.a){if(e.a.match(/^[+\-]/)){e.a="{"+e.a+"}"}f+=e.a+"\\,"}if(e.b||e.p){f+="{\\vphantom{X}}";f+="^{\\hphantom{"+(e.b||"")+"}}_{\\hphantom{"+(e.p||"")+"}}";f+="{\\vphantom{X}}";f+="^{\\smash[t]{\\vphantom{2}}\\llap{"+(e.b||"")+"}}";f+="_{\\vphantom{2}\\llap{\\smash[t]{"+(e.p||"")+"}}}"}if(e.o){if(e.o.match(/^[+\-]/)){e.o="{"+e.o+"}"}f+=e.o}if(e["d-type"]==="kv"){if(e.d||e.q){f+="{\\vphantom{X}}"}if(e.d){f+="^{"+e.d+"}"}if(e.q){f+="_{\\smash[t]{"+e.q+"}}"}}else{if(e["d-type"]==="oxidation"){if(e.d){f+="{\\vphantom{X}}";f+="^{"+e.d+"}"}if(e.q){f+="{\\vphantom{X}}";f+="_{\\smash[t]{"+e.q+"}}"}}else{if(e.q){f+="{\\vphantom{X}}";f+="_{\\smash[t]{"+e.q+"}}"}if(e.d){f+="{\\vphantom{X}}";f+="^{"+e.d+"}"}}}return f},rm:function(e){return"\\mathrm{"+e.p1+"}"},text:function(e){if(e.p1.match(/[\^_]/)){e.p1=e.p1.replace(" ","~").replace("-","\\text{-}");return"\\mathrm{"+e.p1+"}"}else{return"\\text{"+e.p1+"}"}},"roman numeral":function(e){return"\\mathrm{"+e.p1+"}"},"state of aggregation":function(e){return"\\mskip2mu "+a.go2(e.p1)},"state of aggregation subscript":function(e){return"\\mskip1mu "+a.go2(e.p1)},bond:function(f){var e=a.bonds[f.kind];if(!e){throw ["MhchemErrorBond","mhchem Error. Unknown bond type ("+f.kind+")"]}return e},frac:function(e){var f="\\frac{"+e.p1+"}{"+e.p2+"}";return"\\mathchoice{\\textstyle"+f+"}{"+f+"}{"+f+"}{"+f+"}"},"pu-frac":function(e){var f="\\frac{"+a.go2(e.p1)+"}{"+a.go2(e.p2)+"}";return"\\mathchoice{\\textstyle"+f+"}{"+f+"}{"+f+"}{"+f+"}"},"tex-math":function(e){return e.p1+" "},"frac-ce":function(e){return"\\frac{"+a.go2(e.p1)+"}{"+a.go2(e.p2)+"}"},overset:function(e){return"\\overset{"+a.go2(e.p1)+"}{"+a.go2(e.p2)+"}"},underset:function(e){return"\\underset{"+a.go2(e.p1)+"}{"+a.go2(e.p2)+"}"},underbrace:function(e){return"\\underbrace{"+a.go2(e.p1)+"}_{"+a.go2(e.p2)+"}"},color:function(e){return"{\\color{"+e.color1+"}{"+a.go2(e.color2)+"}}"},color0:function(e){return"\\color{"+e.color+"}"},arrow:function(e){e.rd=a.go2(e.rd);e.rq=a.go2(e.rq);var f=a.arrows[e.r];if(e.rd||e.rq){if(e.r==="<=>"||e.r==="<=>>"||e.r==="<<=>"||e.r==="<-->"){f="\\long"+f;if(e.rd){f="\\overset{"+e.rd+"}{"+f+"}"}if(e.rq){f="\\underset{\\lower7mu{"+e.rq+"}}{"+f+"}"}f=" {}\\mathrel{"+f+"}{} "}else{if(e.rq){f+="[{"+e.rq+"}]"}f+="{"+e.rd+"}";f=" {}\\mathrel{\\x"+f+"}{} "}}else{f=" {}\\mathrel{\\long"+f+"}{} "}return f},operator:function(e){return a.operators[e.kind]}},arrows:{"->":"rightarrow","\u2192":"rightarrow","\u27F6":"rightarrow","<-":"leftarrow","<->":"leftrightarrow","<-->":"leftrightarrows","<=>":"rightleftharpoons","\u21CC":"rightleftharpoons","<=>>":"Rightleftharpoons","<<=>":"Leftrightharpoons"},bonds:{"-":"{-}","1":"{-}","=":"{=}","2":"{=}","#":"{\\equiv}","3":"{\\equiv}","~":"{\\tripledash}","~-":"{\\rlap{\\lower.1em{-}}\\raise.1em{\\tripledash}}","~=":"{\\rlap{\\lower.2em{-}}\\rlap{\\raise.2em{\\tripledash}}-}","~--":"{\\rlap{\\lower.2em{-}}\\rlap{\\raise.2em{\\tripledash}}-}","-~-":"{\\rlap{\\lower.2em{-}}\\rlap{\\raise.2em{-}}\\tripledash}","...":"{{\\cdot}{\\cdot}{\\cdot}}","....":"{{\\cdot}{\\cdot}{\\cdot}{\\cdot}}","->":"{\\rightarrow}","<-":"{\\leftarrow}","<":"{<}",">":"{>}"},entities:{space:" ",entitySkip:"~","pu-space-1":"~","pu-space-2":"\\mkern3mu ","1000 separator":"\\mkern2mu ",commaDecimal:"{,}","comma enumeration L":"{{0}}\\mkern6mu ","comma enumeration M":"{{0}}\\mkern3mu ","comma enumeration S":"{{0}}\\mkern1mu ",hyphen:"\\text{-}","addition compound":"\\,{\\cdot}\\,","electron dot":"\\mkern1mu \\bullet\\mkern1mu ","KV x":"{\\times}",prime:"\\prime ",cdot:"\\cdot ","tight cdot":"\\mkern1mu{\\cdot}\\mkern1mu ",times:"\\times ",circa:"{\\sim}","^":"uparrow",v:"downarrow",ellipsis:"\\ldots ","/":"/"," / ":"\\,/\\,","1st-level escape":"{0} "},operators:{"+":" {}+{} ","-":" {}-{} ","=":" {}={} ","<":" {}<{} ",">":" {}>{} ","<<":" {}\\ll{} ",">>":" {}\\gg{} ","\\pm":" {}\\pm{} ","\\approx":" {}\\approx{} ","$\\approx$":" {}\\approx{} ",v:" \\downarrow{} ","(v)":" \\downarrow{} ","^":" \\uparrow{} ","(^)":" \\uparrow{} "},go:function(h,l){if(!h){return h}var k="";var g=false;for(var j=0;j<h.length;j++){var e=h[j];if(typeof e==="string"){k+=e}else{if(this.types[e.type]){k+=this.types[e.type](e)}else{if(this.entities[e.type]){var f=this.entities[e.type];f=f.replace("{0}",e.p1||"");f=f.replace("{1}",e.p2||"");k+=f;if(e.type==="1st-level escape"){g=true}}else{throw ["MhchemBugT","mhchem bug T. Please report."]}}}}if(!l&&!g){k="{"+k+"}"}return k},go2:function(e){return this.go(e,true)}};MathJax.Extension["TeX/mhchem"].CE=c;d.Definitions.Add({macros:{ce:"CE",pu:"PU",xleftrightarrow:["Extension","AMSmath"],xrightleftharpoons:["Extension","AMSmath"],xRightleftharpoons:["Extension","AMSmath"],xLeftrightharpoons:["Extension","AMSmath"],longrightleftharpoons:["Macro","\\stackrel{\\textstyle{-}\\!\\!{\\rightharpoonup}}{\\smash{{\\leftharpoondown}\\!\\!{-}}}"],longRightleftharpoons:["Macro","\\stackrel{\\textstyle{-}\\!\\!{\\rightharpoonup}}{\\smash{\\leftharpoondown}}"],longLeftrightharpoons:["Macro","\\stackrel{\\textstyle\\vphantom{{-}}{\\rightharpoonup}}{\\smash{{\\leftharpoondown}\\!\\!{-}}}"],longleftrightarrows:["Macro","\\stackrel{\\longrightarrow}{\\smash{\\longleftarrow}\\Rule{0px}{.25em}{0px}}"],tripledash:["Macro","\\vphantom{-}\\raise2mu{\\kern2mu\\tiny\\text{-}\\kern1mu\\text{-}\\kern1mu\\text{-}\\kern2mu}"]}},null,true);if(!MathJax.Extension["TeX/AMSmath"]){d.Definitions.Add({macros:{xrightarrow:["Extension","AMSmath"],xleftarrow:["Extension","AMSmath"]}},null,true)}MathJax.Hub.Register.StartupHook("TeX AMSmath Ready",function(){d.Definitions.Add({macros:{xleftrightarrow:["xArrow",8596,6,6],xrightleftharpoons:["xArrow",8652,5,7],xRightleftharpoons:["xArrow",8652,5,7],xLeftrightharpoons:["xArrow",8652,5,7]}},null,true)});d.Parse.Augment({CE:function(g){var e=this.GetArgument(g);var f=c(e).Parse();this.string=f+this.string.substr(this.i);this.i=0},PU:function(g){var e=this.GetArgument(g);var f=c(e).Parse("pu");this.string=f+this.string.substr(this.i);this.i=0}});MathJax.Hub.Startup.signal.Post("TeX mhchem Ready")});MathJax.Ajax.loadComplete("[mhchem]/mhchem.js");
