/*
 *  /MathJax/extensions/a11y/auto-collapse.js
 *
 *  Copyright (c) 2009-2018 The MathJax Consortium
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

(function(c){var d=c.config.menuSettings;var a={};var b=MathJax.Ajax.config.path;if(!b.a11y){b.a11y=c.config.root+"/extensions/a11y"}var e=MathJax.Extension["auto-collapse"]={version:"1.4.0",config:c.CombineConfig("auto-collapse",{disabled:false}),dependents:[],Enable:function(g,f){d.autocollapse=true;if(f){a.autocollapse=true}this.config.disabled=false;MathJax.Extension.collapsible.Enable(false,f);if(g){c.Queue(["Reprocess",c],["CollapseWideMath",this])}},Disable:function(j,h){d.autocollapse=false;if(h){a.autocollapse=false}this.config.disabled=true;for(var f=this.dependents.length-1;f>=0;f--){var g=this.dependents[f];if(g.Disable){g.Disable(false,h)}}if(j){c.Queue(["Rerender",c])}},Dependent:function(f){this.dependents.push(f)},Startup:function(){var f=MathJax.Extension.collapsible;if(f){f.Dependent(this)}c.postInputHooks.Add(["Filter",e],150);c.Queue(function(){return e.CollapseWideMath()});if(window.addEventListener){window.addEventListener("resize",e.resizeHandler,false)}else{if(window.attachEvent){window.attachEvent("onresize",e.resizeHandler)}else{window.onresize=e.resizeHandler}}},Filter:function(f,h,g){if(!f.enriched||this.config.disabled){return}if(f.root.Get("display")==="block"||g.parentNode.childNodes.length<=3){f.root.SRE={action:this.Actions(f.root)}}},Actions:function(f){var g=[];this.getActions(f,0,g);return this.sortActions(g)},getActions:function(h,k,j){if(h.isToken||!h.data){return}k++;for(var g=0,f=h.data.length;g<f;g++){if(h.data[g]){var l=h.data[g];if(l.collapsible){if(!j[k]){j[k]=[]}j[k].push(l);this.getActions(l.data[1],k,j)}else{this.getActions(l,k,j)}}}},sortActions:function(j){var h=[];for(var g=0,f=j.length;g<f;g++){if(j[g]){h=h.concat(j[g].sort(this.sortActionsBy))}}return h},sortActionsBy:function(g,f){g=g.data[1].complexity;f=f.data[1].complexity;return(g<f?-1:g>f?1:0)},CollapseWideMath:function(g){if(this.config.disabled){return}this.GetContainerWidths(g);var f=c.getAllJax(g);var h={collapse:[],jax:f,m:f.length,i:0,changed:false};return this.collapseState(h)},collapseState:function(i){var j=i.collapse;while(i.i<i.m){var f=i.jax[i.i];var h=f.root.SRE;i.changed=false;if(h&&h.action.length){if(h.cwidth<h.m||h.cwidth>h.M){var g=this.getActionWidths(f,i);if(g){return g}this.collapseActions(h,i);if(i.changed){j.push(f.SourceElement())}}}i.i++}if(j.length===0){return}if(j.length===1){j=j[0]}return c.Rerender(j)},collapseActions:function(i,n){var g=i.width,f=g,o=1000000;for(var h=i.action.length-1;h>=0;h--){var l=i.action[h],k=l.selection;if(g>i.cwidth){l.selection=1;f=l.SREwidth;o=g}else{l.selection=2}g=l.SREwidth;if(i.DOMupdate){document.getElementById(l.id).setAttribute("selection",l.selection)}else{if(l.selection!==k){n.changed=true}}}i.m=f;i.M=o},getActionWidths:function(f,h){if(!f.root.SRE.actionWidths){MathJax.OutputJax[f.outputJax].getMetrics(f);try{this.computeActionWidths(f)}catch(g){if(!g.restart){throw g}return MathJax.Callback.After(["collapseState",this,h],g.restart)}h.changed=true}return null},computeActionWidths:function(f){var h=f.root.SRE,l=h.action,g,k={};h.width=f.sreGetRootWidth(k);for(g=l.length-1;g>=0;g--){l[g].selection=2}for(g=l.length-1;g>=0;g--){var i=l[g];if(i.SREwidth==null){i.selection=1;i.SREwidth=f.sreGetActionWidth(k,i)}}h.actionWidths=true},GetContainerWidths:function(h){var k=c.getAllJax(h);var j,g,n,p=MathJax.HTML.Element("span",{style:{display:"block"}});var o=[],f,l;for(j=0,g=k.length;j<g;j++){f=k[j],l=f.root,SRE=l.SRE;if(SRE&&SRE.action.length){if(SRE.width==null){f.sreGetMetrics();SRE.m=SRE.width;SRE.M=1000000}n=f.SourceElement();n.previousSibling.style.display="none";n.parentNode.insertBefore(p.cloneNode(false),n);o.push([f,n])}}for(j=0,g=o.length;j<g;j++){f=o[j][0],n=o[j][1];if(n.previousSibling.offsetWidth){f.root.SRE.cwidth=n.previousSibling.offsetWidth*f.root.SRE.em}}for(j=0,g=o.length;j<g;j++){f=o[j][0],n=o[j][1];n.parentNode.removeChild(n.previousSibling);n.previousSibling.style.display=""}},timer:null,running:false,retry:false,saved_delay:0,resizeHandler:function(f){if(e.config.disabled){return}if(e.running){e.retry=true;return}if(e.timer){clearTimeout(e.timer)}e.timer=setTimeout(e.resizeAction,100)},resizeAction:function(){e.timer=null;e.running=true;c.Queue(function(){e.saved_delay=c.processSectionDelay;c.processSectionDelay=0},["CollapseWideMath",e],["resizeCheck",e])},resizeCheck:function(){e.running=false;c.processSectionDelay=e.saved_delay;if(e.retry){e.retry=false;setTimeout(e.resizeHandler,0)}}};c.Register.StartupHook("End Extensions",function(){if(d.autocollapse==null){d.autocollapse=!e.config.disabled}else{e.config.disabled=!d.autocollapse}c.Register.StartupHook("MathMenu Ready",function(){a=MathJax.Menu.cookie;var g=function(m){e[d.autocollapse?"Enable":"Disable"](true,true);MathJax.Menu.saveCookie()};var f=MathJax.Menu.ITEM,i=MathJax.Menu.menu;var l=f.CHECKBOX(["AutoCollapse","Auto Collapse"],"autocollapse",{action:g});var j=(i.FindId("Accessibility")||{}).submenu,h;if(j){h=j.IndexOfId("AutoCollapse");if(h!==null){j.items[h]=l}else{h=j.IndexOfId("CollapsibleMath");j.items.splice(h+1,0,l)}}else{h=i.IndexOfId("CollapsibleMath");i.items.splice(h+1,0,l)}var k=function(){e[d.autocollapse?"Enable":"Disable"]()};if(MathJax.Extension.collapse){k()}else{MathJax.Hub.Register.StartupHook("Auto Collapse Ready",k)}},25)},25)})(MathJax.Hub);MathJax.ElementJax.Augment({sreGetMetrics:function(){MathJax.OutputJax[this.outputJax].sreGetMetrics(this,this.root.SRE)},sreGetRootWidth:function(a){return MathJax.OutputJax[this.outputJax].sreGetRootWidth(this,a)},sreGetActionWidth:function(b,a){return MathJax.OutputJax[this.outputJax].sreGetActionWidth(this,b,a)}});MathJax.OutputJax.Augment({getMetrics:function(){},sreGetMetrics:function(a,b){b.cwidth=1000000;b.width=0;b.em=12},sreGetRootWidth:function(a,b){return 0},sreGetActionWidth:function(a,c,b){return 0}});MathJax.Hub.Register.StartupHook("HTML-CSS Jax Ready",function(){MathJax.OutputJax["HTML-CSS"].Augment({sreGetMetrics:function(a,b){b.width=a.root.data[0].HTMLspanElement().parentNode.bbox.w;b.em=1/a.HTMLCSS.em/a.HTMLCSS.scale},sreGetRootWidth:function(a,c){var b=a.root.data[0].HTMLspanElement();c.box=b.parentNode;return c.box.bbox.w},sreGetActionWidth:function(a,c,b){return a.root.data[0].toHTML(c.box).bbox.w}})});MathJax.Hub.Register.StartupHook("SVG Jax Ready",function(){MathJax.OutputJax.SVG.Augment({getMetrics:function(a){this.em=MathJax.ElementJax.mml.mbase.prototype.em=a.SVG.em;this.ex=a.SVG.ex;this.linebreakWidth=a.SVG.lineWidth;this.cwidth=a.SVG.cwidth},sreGetMetrics:function(a,b){b.width=a.root.SVGdata.w/1000;b.em=1/a.SVG.em},sreGetRootWidth:function(a,b){b.span=document.getElementById(a.inputID+"-Frame");return a.root.SVGdata.w/1000},sreGetActionWidth:function(a,f,e){this.mathDiv=f.span;f.span.appendChild(this.textSVG);try{var b=a.root.data[0].toSVG()}catch(d){var c=d}f.span.removeChild(this.textSVG);if(c){throw c}return a.root.data[0].SVGdata.w/1000}})});MathJax.Hub.Register.StartupHook("CommonHTML Jax Ready",function(){MathJax.OutputJax.CommonHTML.Augment({sreGetMetrics:function(a,b){b.width=a.root.CHTML.w;b.em=1/a.CHTML.em/a.CHTML.scale},sreGetRootWidth:function(a,b){b.span=document.getElementById(a.inputID+"-Frame").firstChild;b.tmp=document.createElement("span");b.tmp.className=b.span.className;return a.root.CHTML.w/a.CHTML.scale},sreGetActionWidth:function(a,e,d){e.span.parentNode.replaceChild(e.tmp,e.span);MathJax.OutputJax.CommonHTML.CHTMLnode=e.tmp;try{a.root.data[0].toCommonHTML(e.tmp)}catch(c){var b=c}e.tmp.parentNode.replaceChild(e.span,e.tmp);if(b){throw b}return a.root.data[0].CHTML.w/a.CHTML.scale}})});MathJax.Hub.Register.StartupHook("NativeMML Jax Ready",function(){MathJax.OutputJax.NativeMML.Augment({sreGetMetrics:function(a,b){var c=document.getElementById(a.inputID+"-Frame");b.width=c.offsetWidth;b.em=1;b.DOMupdate=true},sreGetRootWidth:function(a,b){b.span=document.getElementById(a.inputID+"-Frame").firstChild;return b.span.offsetWidth},sreGetActionWidth:function(b,e,d){var c=document.getElementById(d.id);c.setAttribute("selection",1);var a=e.span.offsetWidth;return a}})});MathJax.Ajax.Require("[a11y]/collapsible.js");MathJax.Hub.Register.StartupHook("Collapsible Ready",function(){MathJax.Extension["auto-collapse"].Startup();MathJax.Hub.Startup.signal.Post("Auto Collapse Ready");MathJax.Ajax.loadComplete("[a11y]/auto-collapse.js")});
